! matrix vector mulplication

program mv

  use PAPI90

  implicit none

  double precision, dimension(:,:), allocatable:: A
  double precision, dimension(:), allocatable:: B, C, clean 
  integer i, k, j, m, n
  integer*8 start, stop

!----------------------------------------------------------------
! add papi events
!----------------------------------------------------------------
      integer eventarray(4)
      INTEGER retval
      INTEGER*8 values(4)
      INTEGER EventSet

      retval = 2
      call PAPIf_library_init(retval)
	  if ( retval.NE.2) then
	      print *, "PAPI_init fail"
	  end if
      
      call PAPIf_create_eventset(EventSet, retval)
      if ( retval.NE.PAPI_OK) then
	     print *, "PAPI_create_eventset fail"
	  end if

      eventarray(1)=PAPI_L1_DCM
	  eventarray(2)=PAPI_TLB_DM

      call PAPIf_add_events( EventSet, eventarray, 2, retval )  
      if ( retval.NE.PAPI_OK) then
	      print *, "PAPI_add_event fail4"
	  end if


!----------------------------------------------------------------

  m=1024
  n=1024

! allocate array
  allocate(A(m,n), B(n), C(m), clean(m*n*4))

! initialize arrays
  do k=1, n
     call random_number(B(k))
	 B(k)=B(k)*100.0
     do i=1, m
	   call random_number(A(i, k))
	   A(i,k)=A(i,k)*100.0
	 enddo
  enddo

!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case basic_mv
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call basic_mv(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call basic_mv(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "basic_mv  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

  100    format(a13, F10.3)
  200    format(a13, i11, F10.2)
  300    format(a13, i11)



!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ki
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ki(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)


!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ki(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "mv_ki  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)

!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ki_1x4
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ki_1x4(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ki_1x4(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ki_1x4  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)

!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ki_1x8
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ki_1x8(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ki_1x8(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ki_1x8  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)

!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ki_2x8
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ki_2x8(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ki_2x8(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ki_2x8  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)



!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ik_2x1
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ik_2x1(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ik_2x1(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ik_2x1  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)


!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ik_4x1
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ik_4x1(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ik_4x1(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ik_4x1  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)

!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case mv_ik_1x4
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call mv_ik_1x4(m, n, A, B, C)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call mv_ik_1x4(m, n, A, B, C)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "Emv_ik_1x4  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)


!++++++++++++++++++++++++++++++++++++++++++++++++++
! test case ESSL DGEMV
!---------------------------------------------------
! start PAPI counter
!---------------------------------------------------
 ! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo
     call flush_cache(clean, m*n*4)

      call PAPIf_start(EventSet, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_start fail"
	  end if

      call dgemv('N', m, n, 1.0, A, m, B, 1, 1.0, C, 1)

      call PAPIf_stop(EventSet, values, retval)
      if ( retval .NE. PAPI_OK ) then
		 print *, "PAPI_stop fail"
	  end if

  call validate_mv(m, n, a, b, c)

!---------------------------------------------------
! start timer
!--------------------------------------------------- 

! initialize array C to be 0
  do i=1, m
     C(i)=0.0
  enddo

  call flush_cache(clean, m*n*4)

  call PAPIF_get_real_usec(start)
  call dgemv('N', m, n, 1.0, A, m, B, 1, 1.0, C, 1)
  call PAPIF_get_real_usec(stop)

!---------------------------------------------------
! print out result
!---------------------------------------------------
        print *, "ESSL DGEMV  size 1024"
        write (*, 100) 'mflops: ', 2.0 * m * n /(stop-start)
		write (*, 200) 'PAPI_L1_DCM', values(1), 100.0*values(1)/(m*n*1.0)
		write (*, 300) 'PAPI_TLB_DM', values(2) 
		print *, ""

!  100    format(a13, F10.3)
!  200    format(a13, i11, F10.2)
!  300    format(a13, i11)

end program mv

!---------------------------------------------------
! flush_cache will clean cache before calculation
!---------------------------------------------------
subroutine flush_cache(clean, size)

  integer, intent(in) :: size

  double precision, dimension(size) :: clean

  integer i

  do i=1, size
     clean(i)=0.0
  enddo

end subroutine flush_cache


!--------------------------------------------------
! basic_mv is simple straight mv function
! the inner operation: 2 loads, 0 stores
! since fortran array is column-major, it will 
! generate more cache miss and TLB miss
!--------------------------------------------------
subroutine basic_mv(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k
  do i=1, m
     do k=1, n
	    c(i)=c(i)+a(i, k)*b(k)
	 enddo
  enddo

end subroutine basic_mv

!---------------------------------------------------
! mv_ki() is the mv function use ki loop order
! the inner operation: 2 loads, 1 store
! it will have better cache behavior
!---------------------------------------------------
subroutine mv_ki(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k
  do k=1, n
     do i=1, m
	    c(i)=c(i)+a(i, k)*b(k)
	 enddo
  enddo

end subroutine mv_ki

!---------------------------------------------------
! mv_ik_2x1() is the mv function use ki loop order
! it will unroll to depth 4 in i direction
!---------------------------------------------------
subroutine mv_ik_2x1(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, m2
  double precision s0, s1

  m2=INT(m/2)*2
  do i=1, m2, 2
     s0=c(i);
	 s1=c(i+1);

     do k=1, n
	    s0=s0+a(i, k)*b(k)
	    s1=s1+a(i+1, k)*b(k)
	 enddo

	 c(i)=s0
	 c(i+1)=s1
  enddo
  do i=m2+1, m
     do k=1, n
	    c(i)=c(i)+a(i, k)*b(k)
     enddo
  enddo

end subroutine mv_ik_2x1
  
!---------------------------------------------------
! mv_ik_4x1() is the mv function use ki loop order
! it will unroll to depth 4 in i direction
!---------------------------------------------------
subroutine mv_ik_4x1(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, m4
  double precision s0, s1, s2, s3

  m4=INT(m/4)*4
  do i=1, m4, 4
     s0=c(i);
	 s1=c(i+1);
	 s2=c(i+2);
	 s3=c(i+3);

     do k=1, n
	    s0=s0+a(i, k)*b(k)
	    s1=s1+a(i+1, k)*b(k)
	    s2=s2+a(i+2, k)*b(k)
	    s3=s3+a(i+3, k)*b(k)
	 enddo

	 c(i)=s0
	 c(i+1)=s1
	 c(i+2)=s2
	 c(i+3)=s3
  enddo
  do i=m4+1, m
     do k=1, n
	    c(i)=c(i)+a(i, k)*b(k)
     enddo
  enddo

end subroutine mv_ik_4x1

!---------------------------------------------------
! mv_ik_1x4() is the mv function use ki loop order
! it will unroll to depth 4 in i direction
!---------------------------------------------------
subroutine mv_ik_1x4(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, n4
  double precision s0, s1, s2, s3

  n4=INT(n/4)*4
  do i=1, m
     do k=1, n4, 4
	    c(i)=c(i)+a(i, k)*b(k)
	    c(i)=c(i)+a(i, k+1)*b(k+1)
	    c(i)=c(i)+a(i, k+1)*b(k+1)
	    c(i)=c(i)+a(i, k+1)*b(k+1)
	 enddo
	 do k=n4+1, n
	    c(i)=c(i)+a(i, k)*b(k)
	 enddo
  enddo

end subroutine mv_ik_1x4
  
!---------------------------------------------------
! mv_ki_1x4() is the mv function use ki loop order
! it will unroll to depth 4 in i direction
!---------------------------------------------------
subroutine mv_ki_1x4(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, m4

  m4=INT(m/4)*4
  do k=1, n
     do i=1, m4, 4
	    c(i)=c(i)+a(i, k)*b(k)
	    c(i+1)=c(i+1)+a(i+1, k)*b(k)
	    c(i+2)=c(i+2)+a(i+2, k)*b(k)
	    c(i+3)=c(i+3)+a(i+3, k)*b(k)
	 enddo
	 do i=m4+1, m
	    c(i)=c(i)+a(i, k)*b(k)
     enddo
  enddo

end subroutine mv_ki_1x4
  
!---------------------------------------------------
! mv_ki_1x8() is the mv function use ki loop order
! it will unroll to depth 8 in i direction
!---------------------------------------------------
subroutine mv_ki_1x8(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, m8

  m8=INT(m/8)*8
  do k=1, n
     do i=1, m8, 8
	    c(i)=c(i)+a(i, k)*b(k)
	    c(i+1)=c(i)+a(i+1, k)*b(k)
	    c(i+2)=c(i+2)+a(i+2, k)*b(k)
	    c(i+3)=c(i+3)+a(i+3, k)*b(k)
	    c(i+4)=c(i+4)+a(i+4, k)*b(k)
	    c(i+5)=c(i+5)+a(i+5, k)*b(k)
	    c(i+6)=c(i+6)+a(i+6, k)*b(k)
	    c(i+7)=c(i+7)+a(i+7, k)*b(k)
	 enddo
	 do i=m8+1, m
	    c(i)=c(i)+a(i, k)*b(k)
     enddo
  enddo

end subroutine mv_ki_1x8
  
!---------------------------------------------------
! mv_ki_2x8() is the mv function use ki loop order
! block size 2x8, it will unroll to depth 4 in i direction
!                                   depth 2 in k direction
!---------------------------------------------------
subroutine mv_ki_2x8(m, n, a, b, c)
  
  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, k, m8, n2
  double precision ce0, ce1, ce2, ce3, ce4, ce5, ce6, ce7 

  n2=INT(n/2)*2
  m8=INT(m/8)*8
  do k=1, n2, 2
     do i=1, m8, 8
	    ce0=a(i, k)*b(k)
		ce1=a(i+1, k)*b(k)
		ce2=a(i+2, k)*b(k)
		ce3=a(i+3, k)*b(k)
		ce4=a(i+4, k)*b(k)
		ce5=a(i+5, k)*b(k)
		ce6=a(i+6, k)*b(k)
		ce7=a(i+7, k)*b(k)

	    ce0=ce0+a(i, k+1)*b(k+1)
		ce1=ce1+a(i+1, k+1)*b(k+1)
		ce2=ce2+a(i+2, k+1)*b(k+1)
		ce3=ce3+a(i+3, k+1)*b(k+1)
		ce4=ce4+a(i+4, k+1)*b(k+1)
		ce5=ce5+a(i+5, k+1)*b(k+1)
		ce6=ce6+a(i+6, k+1)*b(k+1)
		ce7=ce7+a(i+7, k+1)*b(k+1)

	    c(i)=c(i)+ce0
	    c(i+1)=c(i+1)+ce1
	    c(i+2)=c(i+2)+ce2
	    c(i+3)=c(i+3)+ce3
	    c(i+4)=c(i+4)+ce4
	    c(i+5)=c(i+5)+ce5
	    c(i+6)=c(i+6)+ce6
	    c(i+7)=c(i+7)+ce7

!	    c(i)=c(i)+a(i, k)*b(k)+a(i, k+1)*b(k+1)
!	    c(i+1)=c(i+1)+a(i+1, k)*b(k)+a(i+1, k+1)*b(k+1)
!	    c(i+2)=c(i+2)+a(i+2, k)*b(k)+a(i+2, k+1)*b(k+1)
!	    c(i+3)=c(i+3)+a(i+3, k)*b(k)+a(i+3, k+1)*b(k+1)
!	    c(i+4)=c(i+4)+a(i+4, k)*b(k)+a(i+4, k+1)*b(k+1)
!	    c(i+5)=c(i+5)+a(i+5, k)*b(k)+a(i+5, k+1)*b(k+1)
!	    c(i+6)=c(i+6)+a(i+6, k)*b(k)+a(i+6, k+1)*b(k+1)
!	    c(i+7)=c(i+7)+a(i+7, k)*b(k)+a(i+7, k+1)*b(k+1)
	 enddo
	 do i=m8+1, m
	    c(i)=c(i)+a(i, k)*b(k)
		c(i)=c(i)+a(i, k+1)*b(k+1)
     enddo
  enddo
  do k=n2+1, n
     do i=1, m
	    c(i)=c(i)+a(i, k)*b(k)
	 enddo
  enddo

end subroutine mv_ki_2x8
  
!--------------------------------------------------------
! validate_mv is to validate result
!--------------------------------------------------------
subroutine validate_mv(m, n, a, b, c)

  integer, intent(in) ::         &
        m, n
  double precision, dimension(m,n), intent(in) :: a
  double precision, dimension(n), intent(in) :: b
  double precision, dimension(m) :: c

! local variables
  integer i, j
  double precision A_norm, B_norm, C_norm

  A_norm=0.0
  B_norm=0.0  
  C_norm=0.0
  
  call dgemv('N', m, n, -1.0, A, m, B, 1, 1.0, C, 1)

! The 1-norm is simply the sum of absolute values.
  do i=1, m
     C_norm=C_norm+fabs(c(i))
     do j=1, n
	    A_norm=A_norm+fabs(a(i,j))
	 enddo 
  enddo

  do j=1, n
     B_norm=B_norm+fabs(b(j))
  enddo

!  print *, "relative error: ", C_norm/(A_norm * B_norm) , A_norm, B_norm, C_norm, DBL_EPSILON
  if(C_norm > DBL_EPSILON*A_norm*B_norm) then
     print *, "relative error: ", C_norm/(A_norm * B_norm) 
  end if

end subroutine validate_mv

